stages:
  - Stage
  - Deploy


stage:
  stage: Stage
  resource_group: remote-server
  image: docker-io.monitorsoft.ru/ruby:2.5
  variables:
    project_path: /root/$CI_PROJECT_NAME
  artifacts:
    when: always
    paths:
      - logs/*
  before_script:
    - apt-get update && apt-get install -y -qq ssh rsync
    - mkdir ~/.ssh
    - echo "${SSH_PRIVATE_KEY}" > ~/.ssh/id_rsa && chmod 700 ~/.ssh/id_rsa
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\tPort 22" > ~/.ssh/config && chmod 400 ~/.ssh/config
    - export TARGET_HOST="STAGE_HOST_${CI_COMMIT_REF_NAME}"
#    - env | grep DC_ > .env
    - shopt -s expand_aliases && alias remote="ssh ${!TARGET_HOST} "
  script:
    - rsync --ignore-errors -avzrPR -e ssh --filter 'merge rsync-include.txt' . ${!TARGET_HOST}:$project_path
    - remote "cd $project_path && docker-compose stop && docker-compose rm -v && docker-compose down && docker-compose kill"
    - remote <<EOF
#    - export "$(echo $ALL_ENVS)"
    - cd $project_path
    - rm -f docker-compose.yaml && mv server.docker-compose.yaml docker-compose.yaml
    - chmod +x run.sh && ./run.sh || exit 1
    - EOF
    - rsync --ignore-errors -zavP -e ssh ${!TARGET_HOST}:$project_path/logs .
